diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index e6727abc0..36ed8c103 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -1,19 +1,6 @@
 package net.minecraft.core.world;
 
-import static net.minecraft.core.Global.*;
-
-import java.util.ArrayList;
-import java.util.Collection;
-import java.util.HashSet;
-import java.util.Iterator;
-import java.util.LinkedList;
-import java.util.List;
-import java.util.Random;
-import java.util.Set;
-import java.util.TreeSet;
-
 import com.mojang.nbt.CompoundTag;
-
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.world.chunk.provider.ChunkProviderViewer;
@@ -67,6 +54,19 @@ import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.WeatherManager;
 
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Random;
+import java.util.Set;
+import java.util.TreeSet;
+
+import static net.minecraft.core.Global.DAY_LENGTH_TICKS;
+import static net.minecraft.core.Global.accessor;
+
 public class World implements WorldSource {
 
     public static boolean AUTOSAVE = true;
@@ -117,6 +117,7 @@ public class World implements WorldSource {
     public boolean isClientSide = false;
     public int sleepPercent = 100;
     private long runtime = 0;
+    public boolean updateAllOnLightChange = false;
 
     private final BiomeProvider biomeProvider;
 
@@ -1350,22 +1351,22 @@ public class World implements WorldSource {
     }
 
     public void spawnParticle(String particleKey, double x, double y, double z,
-                              double motionX, double motionY, double motionZ, double maxDistance)
+                              double motionX, double motionY, double motionZ, int data, double maxDistance)
     {
         for(int i = 0; i < listeners.size(); i++)
         {
-            listeners.get(i).addParticle(particleKey, x, y, z, motionX, motionY, motionZ, maxDistance);
+            listeners.get(i).addParticle(particleKey, x, y, z, motionX, motionY, motionZ, data, maxDistance);
         }
 
     }
 
 
     public void spawnParticle(String particleKey, double x, double y, double z,
-            double motionX, double motionY, double motionZ)
+                              double motionX, double motionY, double motionZ, int data)
     {
         for(int i = 0; i < listeners.size(); i++)
         {
-            listeners.get(i).addParticle(particleKey, x, y, z, motionX, motionY, motionZ);
+            listeners.get(i).addParticle(particleKey, x, y, z, motionX, motionY, motionZ, data);
         }
 
     }
@@ -2471,9 +2472,11 @@ public class World implements WorldSource {
         if(i != skyDarken)
         {
             skyDarken = i;
-            for(int j = 0; j < listeners.size(); j++)
-            {
-                ((LevelListener) listeners.get(j)).allChanged();
+            if(updateAllOnLightChange) {
+                for(int j = 0; j < listeners.size(); j++)
+                {
+                    ((LevelListener) listeners.get(j)).allChanged();
+                }	
             }
         }
     }
diff --git a/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java b/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
index 71b6c0d33..fcce4cc74 100644
--- a/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
+++ b/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
@@ -4,9 +4,7 @@
 
 package net.minecraft.core.world.biome;
 
-import net.minecraft.core.entity.animal.EntityWolf;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.entity.SpawnListEntry;
 import net.minecraft.core.world.generate.feature.tree.*;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
@@ -26,12 +24,21 @@ public class BiomeCaatinga extends Biome
     @Override
     public WorldFeature getRandomWorldGenForTrees(Random random)
     {
-        if(random.nextInt(5) == 0)
+        if(random.nextInt(2) == 0)
         {
             return new WorldFeatureTreeShrub(Block.leavesCaatinga.id, Block.logOak.id);
         } else
+        if(random.nextInt(3) == 0)
         {
-            return new WorldFeatureTreeCaatinga(Block.leavesCaatinga.id, Block.logOak.id);
+            return new WorldFeatureTree(Block.leavesCaatinga.id, Block.logOak.id, 6);
+
+        } else
+        if(random.nextInt(3) == 0)
+        {
+            return new WorldFeatureTreeFancy(Block.leavesCaatinga.id, Block.logOak.id);
+        } else
+        {
+            return new WorldFeatureTreeCaatinga(Block.leavesCaatinga.id, Block.logBrazilwood.id);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/biome/BiomeDryForest.java b/src/main/java/net/minecraft/core/world/biome/BiomeDryForest.java
new file mode 100644
index 000000000..2dfd2d990
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/biome/BiomeDryForest.java
@@ -0,0 +1,37 @@
+package net.minecraft.core.world.biome;
+
+import net.minecraft.core.entity.animal.EntityWolf;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeCherry;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeEucalyptus;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+
+import java.util.Random;
+
+public class BiomeDryForest extends BiomeForest
+{
+
+    public BiomeDryForest(String key)
+    {
+        super(key);
+    }
+    @Override
+    public WorldFeature getRandomWorldGenForTrees(Random random)
+    {
+
+        if(random.nextInt(20) == 0)
+        {
+            return new WorldFeatureTree(Block.leavesBirch.id, Block.logBirch.id, 5);
+        }
+        if(random.nextInt(6) == 0)
+        {
+            return new WorldFeatureTreeEucalyptus(Block.leavesEucalyptus.id, Block.logEucalyptus.id);
+        } else
+        {
+            return new WorldFeatureTree(Block.leavesOak.id, Block.logOak.id, 4);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/biome/BiomeForest.java b/src/main/java/net/minecraft/core/world/biome/BiomeForest.java
index e3fbe53fe..fc55be3af 100644
--- a/src/main/java/net/minecraft/core/world/biome/BiomeForest.java
+++ b/src/main/java/net/minecraft/core/world/biome/BiomeForest.java
@@ -26,10 +26,6 @@ public class BiomeForest extends Biome
         {
             return new WorldFeatureTree(Block.leavesBirch.id, Block.logBirch.id, 5);
         }
-        if(random.nextInt(20) == 0)
-        {
-            return new WorldFeatureTreeCherry(Block.leavesCherry.id, Block.logCherry.id, 4);
-        }
         if(random.nextInt(3) == 0)
         {
             return new WorldFeatureTreeFancy(Block.leavesOak.id, Block.logOak.id);
diff --git a/src/main/java/net/minecraft/core/world/biome/BiomePlains.java b/src/main/java/net/minecraft/core/world/biome/BiomePlains.java
new file mode 100644
index 000000000..13de075e0
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/biome/BiomePlains.java
@@ -0,0 +1,20 @@
+package net.minecraft.core.world.biome;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeEucalyptus;
+
+import java.util.Random;
+
+public class BiomePlains extends Biome
+{
+    public BiomePlains(String key) {
+        super(key);
+    }
+
+    @Override
+    public WorldFeature getRandomWorldGenForTrees(Random random)
+    {
+        return new WorldFeatureTreeEucalyptus(Block.leavesEucalyptus.id, Block.logEucalyptus.id);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/biome/Biomes.java b/src/main/java/net/minecraft/core/world/biome/Biomes.java
index 0f37427e6..450145efe 100644
--- a/src/main/java/net/minecraft/core/world/biome/Biomes.java
+++ b/src/main/java/net/minecraft/core/world/biome/Biomes.java
@@ -12,12 +12,12 @@ public class Biomes
     public static final Biome OVERWORLD_SEASONAL_FOREST = register("minecraft:overworld.seasonal_forest", new BiomeSeasonalForest("seasonal_forest").setColor(0x64ce15));
     public static final Biome OVERWORLD_FOREST = register("minecraft:overworld.forest", new BiomeForest("forest").setColor(0x26a615));
     public static final Biome OVERWORLD_GRASSLANDS = register("minecraft:overworld.grasslands", new Biome("grasslands").setColor(0xf0f048).setBlockedWeathers(Weather.overworldSnow));
-    public static final Biome OVERWORLD_OUTBACK = register("minecraft:overworld.outback", new Biome("outback").setColor(0xd95e20).setBlockedWeathers(Weather.overworldSnow).setTopBlock(Block.dirtScorched.id).setFillerBlock(Block.dirtScorched.id));
+    public static final Biome OVERWORLD_OUTBACK = register("minecraft:overworld.outback", new BiomeOutback("outback").setColor(0xd95e20).setBlockedWeathers(Weather.overworldSnow).setTopBlock(Block.dirtScorched.id).setFillerBlock(Block.dirtScorched.id));
     public static final Biome OVERWORLD_SHRUBLAND = register("minecraft:overworld.shrubland", new BiomeShrubland("shrubland").setColor(0xbaba38));
     public static final Biome OVERWORLD_TAIGA = register("minecraft:overworld.taiga", new BiomeTaiga("taiga").setColor(0x8abcff).setSurfaceSnow());
     public static final Biome OVERWORLD_BOREAL_FOREST = register("minecraft:overworld.boreal_forest", new BiomeBorealForest("boreal_forest").setColor(0x148564));
     public static final Biome OVERWORLD_DESERT = register("minecraft:overworld.desert", new Biome("desert").setColor(0xEDE26F).setBlockedWeathers(Weather.overworldRain, Weather.overworldSnow, Weather.overworldStorm).setTopBlock(Block.sand.id).setFillerBlock(Block.sand.id));
-    public static final Biome OVERWORLD_PLAINS = register("minecraft:overworld.plains", new Biome("plains").setColor(0xA3C649));
+    public static final Biome OVERWORLD_PLAINS = register("minecraft:overworld.plains", new BiomePlains("plains").setColor(0xA3C649));
     public static final Biome OVERWORLD_GLACIER = register("minecraft:overworld.glacier", new Biome("glacier").setColor(0xcbf6ff).setSurfaceSnow().setTopBlock(Block.blockSnow.id).setFillerBlock(Block.blockSnow.id));
     public static final Biome OVERWORLD_TUNDRA = register("minecraft:overworld.tundra", new Biome("tundra").setColor(0x57e0ff).setSurfaceSnow());
     public static final Biome OVERWORLD_MEADOW = register("minecraft:overworld.meadow", new BiomeBorealForest("meadow").setColor(0x8c8c22));
@@ -28,7 +28,9 @@ public class Biomes
     public static final Biome OVERWORLD_HELL = register("minecraft:overworld.hell", new Biome("hell").setColor(0xD96223).setTopBlock(Block.dirtScorched.id).setTopBlock(Block.dirtScorched.id));
     public static final Biome OVERWORLD_SWAMPLAND_MUDDY = register("minecraft:overworld.swampland.muddy", new BiomeSwamp("swampland.muddy").setColor(0x522700));
     public static final Biome OVERWORLD_OUTBACK_GRASSY = register("minecraft:overworld.outback.grassy", new BiomeOutback("outback.grassy").setColor(0xf09037).setBlockedWeathers(Weather.overworldSnow).setTopBlock(Block.grassScorched.id).setFillerBlock(Block.dirtScorched.id));
-    public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("caatinga").setColor(0xFFFFFF).setTopBlock(Block.mudBaked.id).setFillerBlock(Block.mudBaked.id).setBlockedWeathers(Weather.overworldSnow));
+    public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("caatinga").setColor(0xdecda6).setTopBlock(Block.mudBaked.id).setFillerBlock(Block.mudBaked.id).setBlockedWeathers(Weather.overworldSnow));
+    public static final Biome OVERWORLD_CAATINGA_PLAINS = register("minecraft:overworld.caatinga.plains", new Biome("caatinga.plains").setColor(0xa19477).setTopBlock(Block.mudBaked.id).setFillerBlock(Block.mudBaked.id).setBlockedWeathers(Weather.overworldSnow));
+    public static final Biome OVERWORLD_FOREST_DRY = register("minecraft:overworld.forest.dry", new BiomeDryForest("forest.dry").setColor(0x85c472));
 
     public static Biome register(String key, Biome biome)
     {
diff --git a/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java b/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
index f02eb65cd..f61fcaf5f 100644
--- a/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
+++ b/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
@@ -349,7 +349,6 @@ public final class BiomeProviderOverworld
         );
         brm.addRange(Biomes.OVERWORLD_GRASSLANDS,
             new BiomeRange(0.5, 0.98, 0.0, 0.05, 0.0, 1.0, 0.0, 1.0),
-                new BiomeRange(0.75, 0.95, 0.05, 0.3, 0.0, 1.0, 0.0, 1.0),
                 new BiomeRange(0.95, 1.0, 0.2, 0.5, 0.0, 1.0, 0.0, 1.0)
         );
         brm.addRange(Biomes.OVERWORLD_MEADOW,
@@ -358,13 +357,12 @@ public final class BiomeProviderOverworld
         brm.addRange(Biomes.OVERWORLD_BIRCH_FOREST,
                 new BiomeRange(0.5, 0.75, 0.2, 0.4, 0.0, 1.0, 0.0, 1.0)
         );
-
         brm.addRange(Biomes.OVERWORLD_SHRUBLAND,
                 new BiomeRange(0.5, 0.75, 0.05, 0.2, 0.0, 1.0, 0.0, 1.0)
         );
-
         brm.addRange(Biomes.OVERWORLD_PLAINS,
-                new BiomeRange(0.90, 1.0, 0.0125, 0.5, 0.0, 1.0, 0.0, 1.0)
+                new BiomeRange(0.75, 0.95, 0.01, 0.2, 0.0, 1.0, 0.0, 1.0),
+                new BiomeRange(0.75, 0.95, 0.2, 0.4, 0.0, 1.0, 0.95, 1.0)
         );
         brm.addRange(Biomes.OVERWORLD_DESERT,
                 new BiomeRange(0.95, 1.0, 0.0, 0.2, 0.0, 1.0, 0.0, 1.0)
@@ -383,22 +381,26 @@ public final class BiomeProviderOverworld
                 new BiomeRange(0.75, 0.95, 0.85, 1.0, 0.0, 1.0, 0.0, 1.0)
         );
         brm.addRange(Biomes.OVERWORLD_FOREST,
-                new BiomeRange(0.75, 0.95, 0.2, 0.85, 0.0, 1.0, 0.0, 1.0),
-                new BiomeRange(0.95, 1.0, 0.5, 0.85, 0.0, 1.0, 0.0, 1.0)
+                new BiomeRange(0.75, 0.95, 0.2, 0.85, 0.0, 1.0, 0.0, 1),
+                new BiomeRange(0.95, 1.0, 0.4, 0.85, 0.0, 1.0, 0.0, 1)
+        );
+        brm.addRange(Biomes.OVERWORLD_FOREST_DRY,
+                new BiomeRange(0.75, 0.95, 0.2, 0.4, 0.0, 1.0, 0.0, 0.95)
         );
         brm.addRange(Biomes.OVERWORLD_CAATINGA,
-                new BiomeRange(0.98, 1.0, 0.2, 0.65, 0.0, 1.0, 0.0, 1.0)
+                new BiomeRange(0.95, 1.0, 0.2, 0.4, 0.0, 1.0, 0.0, 0.75)
+        );
+        brm.addRange(Biomes.OVERWORLD_CAATINGA_PLAINS,
+                new BiomeRange(0.95, 1.0, 0.2, 0.4, 0.0, 1.0, 0.75, 1.0)
+        );
+        brm.addRange(Biomes.OVERWORLD_CAATINGA,
+                new BiomeRange(0.95, 1.0, 0.2, 0.4, 0.0, 1.0, 0.0, 1.0)
         );
         brm.addRange(Biomes.OVERWORLD_RAINFOREST,
                 new BiomeRange(0.95, 1.0, 0.85, 1.0, 0.0, 1.0, 0.0, 1.0)
         );
         brm.lock();
 
-//        if (brm.hasGaps())
-//        {
-//            throw new RuntimeException("Gap in biome map!");
-//        }
-
-//        brm.generateDebugImage(true);
+        brm.generateDebugImage(true);
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index 5bfae16bc..d1a857c08 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -234,6 +234,9 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_FOREST) {
             treeDensity += k4 + 5;
         }
+        if (biome == Biomes.OVERWORLD_FOREST_DRY) {
+            treeDensity += k4 + 1;
+        }
         if (biome == Biomes.OVERWORLD_BIRCH_FOREST) {
             treeDensity += k4 + 4;
         }
@@ -255,11 +258,11 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_TUNDRA) {
             treeDensity -= 20;
         }
-        if (biome == Biomes.OVERWORLD_PLAINS) {
-            treeDensity -= 20;
-        }
         if (biome == Biomes.OVERWORLD_CAATINGA) {
-            treeDensity += k4 + 2;
+            treeDensity += k4 + 10;
+        }
+        if (biome == Biomes.OVERWORLD_CAATINGA_PLAINS) {
+            treeDensity -= 10;
         }
         if (biome == Biomes.OVERWORLD_SWAMPLAND) {
             treeDensity += k4 + 4;
@@ -336,10 +339,7 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_RAINFOREST) {
             byteBluebells = 4;
         }
-        if (biome == Biomes.OVERWORLD_GRASSLANDS) {
-            byteBluebells = 3;
-        }
-        if (biome == Biomes.OVERWORLD_CAATINGA) {
+        if (biome == Biomes.OVERWORLD_CAATINGA || biome == Biomes.OVERWORLD_CAATINGA_PLAINS) {
             byteBluebells = 3;
         }
 
@@ -350,6 +350,28 @@ public class ChunkDecoratorOverworld
             (new WorldFeatureFlowers(Block.flowerLightBlue.id)).generate(world, rand, k14, l16, k19);
         }
 
+        byte byteMarigold = 0;
+
+        if (biome == Biomes.OVERWORLD_GRASSLANDS) {
+            byteMarigold = 1;
+        }
+        if (biome == Biomes.OVERWORLD_FOREST_DRY) {
+            byteMarigold = 1;
+        }
+        if (biome == Biomes.OVERWORLD_PLAINS) {
+            byteMarigold = 5;
+        }
+        if (biome == Biomes.OVERWORLD_OUTBACK_GRASSY || biome == Biomes.OVERWORLD_OUTBACK) {
+            byteMarigold = 3;
+        }
+
+        for (int i14 = 0; i14 < byteMarigold; i14++) {
+            int k14 = x + rand.nextInt(16) + 8;
+            int l16 = minY + rand.nextInt(rangeY);
+            int k19 = z + rand.nextInt(16) + 8;
+            (new WorldFeatureFlowers(Block.flowerOrange.id)).generate(world, rand, k14, l16, k19);
+        }
+
         byte byte0 = 0;
         if (biome == Biomes.OVERWORLD_FOREST) {
             byte0 = 2;
@@ -363,9 +385,10 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_PLAINS) {
             byte0 = 3;
         }
-        if (biome == Biomes.OVERWORLD_CAATINGA) {
+        if (biome == Biomes.OVERWORLD_CAATINGA || biome == Biomes.OVERWORLD_CAATINGA_PLAINS) {
             byte0 = 5;
         }
+
         if (biome == Biomes.OVERWORLD_OUTBACK_GRASSY || biome == Biomes.OVERWORLD_OUTBACK) {
             byte0 = 2;
         }
@@ -405,6 +428,9 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_CAATINGA) {
             byte1 = 3;
         }
+        if (biome == Biomes.OVERWORLD_CAATINGA_PLAINS) {
+            byte1 = 1;
+        }
         if (biome == Biomes.OVERWORLD_SWAMPLAND) {
             byte1 = 4;
         }
@@ -417,6 +443,9 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_BIRCH_FOREST) {
             byte1 = 2;
         }
+        if (biome == Biomes.OVERWORLD_FOREST_DRY) {
+            byte1 = 3;
+        }
         for (int l14 = 0; l14 < byte1; l14++) {
             int type = Block.tallgrass.id;
             if ((biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_BOREAL_FOREST || biome == Biomes.OVERWORLD_TAIGA) && rand.nextInt(3) != 0) {
@@ -496,7 +525,7 @@ public class ChunkDecoratorOverworld
         {
             k16 += 10;
         }
-        if(biome == Biomes.OVERWORLD_CAATINGA)
+        if(biome == Biomes.OVERWORLD_CAATINGA || biome == Biomes.OVERWORLD_CAATINGA_PLAINS)
         {
             k16 += 3;
         }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
index 500c7c9df..fc4baade8 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
@@ -142,31 +142,40 @@ public class SurfaceGeneratorOverworld
                             topBlock = 0;
                             fillerBlock = (short) worldFillBlock;
                         }
-                        else if(y >= minY + oceanY - 4 && y <= minY + oceanY + 1)
-                        {
-                            // generate coastlines
-                            topBlock = biome.topBlock;
-                            fillerBlock = biome.fillerBlock;
-                            if(biome == Biomes.OVERWORLD_CAATINGA || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_SWAMPLAND_MUDDY)
-                            {
-                                topBlock = (short) Block.mud.id;
-                                fillerBlock = (short) Block.mud.id;
-                            }
-                            else if(generateGravelBeach)
-                            {
-                                topBlock = 0;
-                                fillerBlock = (short) Block.gravel.id;
-                            }
-                            else if(generateSandBeach)
-                            {
-                                topBlock = (short) Block.sand.id;
-                                fillerBlock = (short) Block.sand.id;
-                            }
-                        } else if (y <= oceanY) {
-                            if(biome == Biomes.OVERWORLD_CAATINGA || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_SWAMPLAND_MUDDY) // Make mud under the ocean always be regular mud
+                        else {
+                            //todo: biome tags
+                            boolean biomeGeneratesMud = biome ==
+                                    Biomes.OVERWORLD_CAATINGA_PLAINS ||
+                                    biome == Biomes.OVERWORLD_CAATINGA ||
+                                    biome == Biomes.OVERWORLD_SWAMPLAND ||
+                                    biome == Biomes.OVERWORLD_SWAMPLAND_MUDDY;
+
+                            if(y >= minY + oceanY - 4 && y <= minY + oceanY + 1)
                             {
-                                topBlock = (short) Block.mud.id;
-                                fillerBlock = (short) Block.mud.id;
+                                // generate coastlines
+                                topBlock = biome.topBlock;
+                                fillerBlock = biome.fillerBlock;
+                                if(biomeGeneratesMud)
+                                {
+                                    topBlock = (short) Block.mud.id;
+                                    fillerBlock = (short) Block.mud.id;
+                                }
+                                else if(generateGravelBeach)
+                                {
+                                    topBlock = 0;
+                                    fillerBlock = (short) Block.gravel.id;
+                                }
+                                else if(generateSandBeach)
+                                {
+                                    topBlock = (short) Block.sand.id;
+                                    fillerBlock = (short) Block.sand.id;
+                                }
+                            } else if (y <= oceanY) {
+                                if(biomeGeneratesMud) // Make mud under the ocean always be regular mud
+                                {
+                                    topBlock = (short) Block.mud.id;
+                                    fillerBlock = (short) Block.mud.id;
+                                }
                             }
                         }
 
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
index a50560754..5f990d1b3 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
@@ -12,7 +12,7 @@ public class WorldFeatureTreeCaatinga extends WorldFeature
 {
     protected int leavesID;
     protected int logID;
-    protected int heightMod = 2;
+    protected int heightMod = 3;
 
     public WorldFeatureTreeCaatinga(int leavesID, int logID)
     {
@@ -122,9 +122,9 @@ public class WorldFeatureTreeCaatinga extends WorldFeature
         }
         WorldFeatureTree.onTreeGrown(world, x, y, z);
         for(int i = 0; i < noCanopies; i++) {
-            int modX = random.nextInt(6) - 3;
-            int modZ = random.nextInt(6) - 3;
-            int modY = random.nextInt(3) + 1;
+            int modX = random.nextInt(8) - 4;
+            int modZ = random.nextInt(8) - 4;
+            int modY = random.nextInt(4) + 1;
             int x1 = x + modX;
             int z1 = z + modZ;
 
diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldDefault.java b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldDefault.java
index 70f76266b..7cf10558a 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldDefault.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldDefault.java
@@ -18,10 +18,10 @@ public class WorldTypeOverworldDefault
             Weather.overworldClear,
             new WindManagerGeneric(),
             SeasonConfig.builder()
-                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 7)
+                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 14)
                 .build()
         );
     }
diff --git a/src/main/java/net/minecraft/server/world/WorldManager.java b/src/main/java/net/minecraft/server/world/WorldManager.java
index 049791685..eeada38d3 100644
--- a/src/main/java/net/minecraft/server/world/WorldManager.java
+++ b/src/main/java/net/minecraft/server/world/WorldManager.java
@@ -36,13 +36,13 @@ public class WorldManager
 
     @Override
 	public void addParticle(String particleKey, double x, double y, double z,
-                            double motionX, double motionY, double motionZ, double maxDistance)
+                            double motionX, double motionY, double motionZ, int data, double maxDistance)
     {
     }
 
     @Override
 	public void addParticle(String particleKey, double x, double y, double z,
-                            double motionX, double motionY, double motionZ)
+                            double motionX, double motionY, double motionZ, int data)
     {
     }
 
